// $ANTLR 2.7.7 (2006-11-01): "bnf.g" -> "BNF_Parser.java"$

    package com.unitesk.atp.bnf;

    import java.util.List;
    import java.util.ArrayList;

    import java.io.File;

    import com.unitesk.atp.tree.tool.antlr.LinkedToken; 
    import com.unitesk.atp.text.location.Position;
    import com.unitesk.atp.messages.*;

    import com.unitesk.atp.bnf.BNFModel.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class BNF_Parser extends antlr.LLkParser       implements BNF_LexerTokenTypes
 {

    protected File file;
    protected MessageBox mbox;

    public BNF_Parser( TokenStream lexer
                     , File p_file
                     , MessageBox p_mbox
                     )
	{
		this( lexer );
                file = p_file;
		mbox = p_mbox;
	}

    public void reportError( RecognitionException ex )
    {
        if( mbox != null )
        {
            mbox.error( new SyntaxErrorMessage( file
                                              , new Position( ex.getLine(), ex.getColumn() )
                                              , ex.getMessage()
                                              )
                      );
        } else {
            super.reportError( ex );
        }
    }

    public void reportError( String s )
    {
        if( mbox != null )
        {
            mbox.error( new SyntaxErrorMessage( file, null, s ) );
        } else {
            super.reportError( s );
        }
    }

    public void reportWarning( String s )
    {
        if( mbox != null )
        {
            mbox.warning( new SyntaxErrorMessage( file, null, s ) );
        } else {
            super.reportWarning( s );
        }
    }


protected BNF_Parser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public BNF_Parser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected BNF_Parser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public BNF_Parser(TokenStream lexer) {
  this(lexer,1);
}

public BNF_Parser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final Grammar  grammar() throws RecognitionException, TokenStreamException {
		Grammar g;
		
		
		g = null;
		
		
		try {      // for error handling
			
			List/*Rule*/ l = new ArrayList/*Rule*/();
			Rule r;
			
			{
			int _cnt53=0;
			_loop53:
			do {
				if ((LA(1)==ID||LA(1)==DOCOMMENT)) {
					r=rule();
					l.add( r );
				}
				else {
					if ( _cnt53>=1 ) { break _loop53; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt53++;
			} while (true);
			}
			match(Token.EOF_TYPE);
			g = new Grammar( l );
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_0);
		}
		return g;
	}
	
	public final Rule  rule() throws RecognitionException, TokenStreamException {
		Rule r;
		
		Token  jd = null;
		
		r = null;
		
		
		try {      // for error handling
			
			ID i;
			Expression e;
			
			{
			switch ( LA(1)) {
			case DOCOMMENT:
			{
				jd = LT(1);
				match(DOCOMMENT);
				break;
			}
			case ID:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			i=id();
			{
			}
			match(DEFINE);
			e=expression();
			{
			}
			match(SEMI);
			r = new Rule( jd != null ? jd.getText() : null, i, e );
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_1);
		}
		return r;
	}
	
	public final ID  id() throws RecognitionException, TokenStreamException {
		ID id;
		
		Token  t = null;
		
		id = null;
		
		
		try {      // for error handling
			t = LT(1);
			match(ID);
			
			id = new ID( new Position( t.getLine(), t.getColumn() )
			, t.getText()
			, (LinkedToken)t 
			);
			
			((LinkedToken)t).setNode( id );
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		return id;
	}
	
	public final Expression  expression() throws RecognitionException, TokenStreamException {
		Expression e;
		
		
		e = null; 
		
		
		try {      // for error handling
			
			List/*Term*/ l = new ArrayList/*Term*/();
			Term t;
			
			t=term();
			{
			}
			l.add( t );
			{
			_loop62:
			do {
				if ((LA(1)==OR)) {
					match(OR);
					t=term();
					{
					}
					l.add( t );
				}
				else {
					break _loop62;
				}
				
			} while (true);
			}
			e = new Expression( l );
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_3);
		}
		return e;
	}
	
	public final Term  term() throws RecognitionException, TokenStreamException {
		Term t;
		
		Token  jd = null;
		
		t = null;
		String comment = null;
		
		
		try {      // for error handling
			
			List/*Factor*/ l = new ArrayList/*Factor*/();
			Factor f;
			
			{
			switch ( LA(1)) {
			case DOCOMMENT:
			{
				jd = LT(1);
				match(DOCOMMENT);
				comment = jd.getText();
				break;
			}
			case LB:
			case ID:
			case LEXEME_NAME:
			case LEXEME_TEXT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			int _cnt67=0;
			_loop67:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					f=factor();
					{
					}
					
					f.setOptPreDocomment( comment );
					comment = f.getOptPostDocomment();
					l.add( f );
					
				}
				else {
					if ( _cnt67>=1 ) { break _loop67; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt67++;
			} while (true);
			}
			t = new Term( l );
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_5);
		}
		return t;
	}
	
	public final Factor  factor() throws RecognitionException, TokenStreamException {
		Factor f;
		
		Token  lt = null;
		Token  ln = null;
		Token  jd = null;
		
		f = null;
		ID id = null;
		ID id2 = null;
		Expression e;
		int kind = Expression_Factor.DEFAULT;
		
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case ID:
			{
				id=id();
				{
				}
				{
				switch ( LA(1)) {
				case COLON:
				{
					match(COLON);
					id2=id();
					{
					}
					break;
				}
				case SEMI:
				case OR:
				case LB:
				case RB:
				case ID:
				case LEXEME_NAME:
				case LEXEME_TEXT:
				case DOCOMMENT:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				f = ( id2 == null
				? new Name_Factor( id )
				: new Name_Factor( id2, id )
				);
				
				break;
			}
			case LEXEME_TEXT:
			{
				lt = LT(1);
				match(LEXEME_TEXT);
				f = new Lexeme_Factor( lt.getText() );
				break;
			}
			case LEXEME_NAME:
			{
				ln = LT(1);
				match(LEXEME_NAME);
				f = new Lexeme_Factor( ln.getText() );
				break;
			}
			case LB:
			{
				match(LB);
				e=expression();
				{
				}
				match(RB);
				{
				switch ( LA(1)) {
				case OPT:
				{
					match(OPT);
					kind = Expression_Factor.OPTIONAL;
					break;
				}
				case ZERO_LIST:
				{
					match(ZERO_LIST);
					kind = Expression_Factor.ZERO_LIST;
					break;
				}
				case ONE_LIST:
				{
					match(ONE_LIST);
					kind = Expression_Factor.ONE_LIST;
					break;
				}
				case TRANS_LIST:
				{
					match(TRANS_LIST);
					kind = Expression_Factor.TRANSPOSITION;
					break;
				}
				case SEMI:
				case OR:
				case LB:
				case RB:
				case ID:
				case LEXEME_NAME:
				case LEXEME_TEXT:
				case DOCOMMENT:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				f = new Expression_Factor( kind, e );
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case DOCOMMENT:
			{
				jd = LT(1);
				match(DOCOMMENT);
				f.setOptPostDocomment( jd.getText() );
				break;
			}
			case SEMI:
			case OR:
			case LB:
			case RB:
			case ID:
			case LEXEME_NAME:
			case LEXEME_TEXT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_6);
		}
		return f;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"WS",
		"SL_COMMENT",
		"ML_COMMENT",
		"COMMENT",
		"ESC",
		"HEX_DIGIT",
		"LETTER",
		"DIGIT",
		"DEFINE",
		"COLON",
		"SEMI",
		"OR",
		"LB",
		"RB",
		"OPT",
		"ZERO_LIST",
		"ONE_LIST",
		"TRANS_LIST",
		"ID",
		"LEXEME_NAME",
		"LEXEME_TEXT",
		"DOCOMMENT"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 37748738L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 63172608L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 147456L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 29425664L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 180224L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 29605888L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	
	}
