/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

//==============================================================================

package com.unitesk.atp.bnf.actions.toTreeDL;

//==============================================================================

import java.util.Hashtable;
import java.util.Vector;

//==============================================================================

public class AlterTerm
{
    private Vector factor_list;
    public AlterTerm( Vector fl )
    {
        factor_list = fl; 
    }
    
    public Vector getFactorList()
    {
        return factor_list;
    }

    public Object getFactorList( int i )
    {
        return (Object)getFactorList().get( i );
    }

    public int sizeFactorList()
    {
        return getFactorList().size();
    }
}
