/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.atp.bnf;

/**
 * @author <A href="mailto:zelenov@ispras.ru">Sergey Zelenov</A>
 * @version $Id$
 */
public class SynTesK extends BNFLauncher
{
    protected void initName()
    {
        name = "syntesk";
        version = "1.1.2-stable-240911";
    }

    public static void main( String[] args )
    {
        SynTesK syntesk = new SynTesK();
        System.out.println( "SynTESK, version " + syntesk.getVersion() );
        System.out.println( "Syntax Testing Kit" );
        System.out.println( "(C) Institute for System Programming of Russian Academy of Sciences" );
        System.out.println( "    RedVerst group" );
        System.out.println( "http://www.unitesk.com/" );
        System.out.println();
        syntesk.run( args );
    }
}
