/*
 * Copyright 2001-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.atp.bnf.messages;

import com.unitesk.atp.messages.Message;

public class NoRealizationMessage implements Message
{
    public NoRealizationMessage( String p_rule, int p_depth )
    {
        rule = p_rule;
        depth = p_depth;
    }

    public String getRule() { return rule; }
    public int getDepth() { return depth; }

    private final String rule;
    private final int depth;
}
